{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#collect-ometiff-files.cwl",
            "label": "Collect OME-TIFF files",
            "requirements": [
                {
                    "dockerPull": "hubmap/ome-tiff-pyramid:1.3",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.ometiff_directory)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "The directory OME-TIFF files",
                    "id": "#collect-ometiff-files.cwl/Collect OME-TIFF files/ometiff_directory"
                }
            ],
            "baseCommand": [
                "/opt/collect_ometiff_files.py"
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "glob": "ometiffs.json",
                        "loadContents": true,
                        "outputEval": "${return JSON.parse(self[0].contents).directories;}"
                    },
                    "id": "#collect-ometiff-files.cwl/Collect OME-TIFF files/base_directory"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "ometiffs.json",
                        "loadContents": true,
                        "outputEval": "${return JSON.parse(self[0].contents).files;}"
                    },
                    "id": "#collect-ometiff-files.cwl/Collect OME-TIFF files/ometiff_file"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/downsample_type"
                },
                {
                    "type": "Directory",
                    "id": "#main/ometiff_directory"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#main/processes"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/rgb"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": "#main/convert_to_pyramid/n5_dir",
                    "id": "#main/n5_dir"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "outputSource": "#main/convert_to_pyramid/pyramid_dir",
                    "id": "#main/pyramid_dir"
                }
            ],
            "steps": [
                {
                    "run": "#collect-ometiff-files.cwl",
                    "in": [
                        {
                            "source": "#main/ometiff_directory",
                            "id": "#main/collect_ometiff_files/ometiff_directory"
                        }
                    ],
                    "out": [
                        "#main/collect_ometiff_files/ometiff_file",
                        "#main/collect_ometiff_files/base_directory"
                    ],
                    "id": "#main/collect_ometiff_files"
                },
                {
                    "scatter": [
                        "#main/convert_to_pyramid/ometiff_file",
                        "#main/convert_to_pyramid/base_directory"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#ometiff-to-pyramid.cwl",
                    "in": [
                        {
                            "source": "#main/collect_ometiff_files/base_directory",
                            "id": "#main/convert_to_pyramid/base_directory"
                        },
                        {
                            "source": "#main/downsample_type",
                            "id": "#main/convert_to_pyramid/downsample_type"
                        },
                        {
                            "source": "#main/collect_ometiff_files/ometiff_file",
                            "id": "#main/convert_to_pyramid/ometiff_file"
                        },
                        {
                            "source": "#main/processes",
                            "id": "#main/convert_to_pyramid/processes"
                        },
                        {
                            "source": "#main/rgb",
                            "id": "#main/convert_to_pyramid/rgb"
                        }
                    ],
                    "out": [
                        "#main/convert_to_pyramid/pyramid_dir",
                        "#main/convert_to_pyramid/n5_dir"
                    ],
                    "id": "#main/convert_to_pyramid"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "hubmap/ome-tiff-pyramid:1.3",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#ometiff-to-pyramid.cwl/base_directory"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--downsample-type",
                        "position": 4
                    },
                    "id": "#ometiff-to-pyramid.cwl/downsample_type"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    },
                    "id": "#ometiff-to-pyramid.cwl/ometiff_file"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#ometiff-to-pyramid.cwl/processes"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--rgb",
                        "position": 3
                    },
                    "id": "#ometiff-to-pyramid.cwl/rgb"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "n5"
                    },
                    "id": "#ometiff-to-pyramid.cwl/n5_dir"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "ometiff-pyramids"
                    },
                    "id": "#ometiff-to-pyramid.cwl/pyramid_dir"
                }
            ],
            "baseCommand": [
                "python3",
                "/opt/ometiff_to_pyramid.py"
            ],
            "id": "#ometiff-to-pyramid.cwl"
        }
    ],
    "cwlVersion": "v1.1"
}
